local sprite = require("Sprites/sprite")

item = {}
item.__index = item

function item:new(n, t)
    local self = setmetatable({}, self)

    self.name = n
    self.texture = t

    self.sprite = sprite:new()
    self.sprite.texture = self.texture

    return self
end

function item:update(dt)
    sprite.update(self, dt)
end

function item:draw()
    if self.animated then
        love.graphics.draw(self.currentanim.atlas, self.currentanim:getquad(), self.x, self.y, 0, self:hscale(), self:vscale(), 0, 0)
    else
        love.graphics.draw(self.sprite.texture, self.sprite.quad, self.invx * self.inv.bWidth + self.inv.sx + self.inv.bx, self.invy * self.inv.bHeight + self.inv.sy + self.inv.by, 0, self.sprite:hscale(), self.sprite:vscale(), 0, 0)
    end
end

function item:setInvPos(nx, ny)
    
end

return item