local sprite = require("Sprites/sprite")

local item = require("Models/Items/item")

local functions = require("functions")
local statics = require("statics")

inventory = {}
inventory.__index = inventory

function inventory:new()
    local self = setmetatable({}, self)

    self.items = {}

    self.x = 100
    self.y = 50

    self.background = sprite:new()
    self.background.texture = love.graphics.newImage("Assets/Graphics/UI/inventory.png")
    self.background.quad = functions.setDefaultQuad(self.background.texture)
    self.background.x = self.x
    self.background.y = self.y

    self.items[1] = item:new("test", love.graphics.newImage("Assets/Graphics/Items/items.png"))
    self.items[1].sprite.quad = love.graphics.newQuad(0, 0, 16, 16, self.items[1].sprite.texture:getDimensions())
    self.items[1].inv = { sx = self.x, bx = 2, bWidth = 16 * statics.scale, sy = self.y, by = 0, bHeight = 16 * statics.scale}
    self.items[1].invx = 2
    self.items[1].invy = 1

    return self
end

function inventory:update(dt)

end

function inventory:draw()
    self.background:draw()

    for k, v in pairs(self.items) do
        v:draw()
    end
end

return inventory