local animation = {}
animation.__index = animation

animation.properties = 
{
    atlas,
    speed,
    framecount,
    framewidth,
    frameheight,
    fields = 
    {
        timer = 0,
        framecounter = 0,
    }
}

function animation.new(a, s, fc, fw, fh)
    local self = setmetatable({}, animation)

    self.atlas = a
    self.speed = s
    self.framecount = fc
    self.framewidth = fw
    self.frameheight = fh

    self.fields = {}
    self.fields.timer = 0
    self.fields.framecounter = 0

    return self
end

function animation:update(dt)
    self.fields.timer = self.fields.timer + 1

    if self.fields.timer >= self.speed then
        self.fields.timer = 0

        self.fields.framecounter = self.fields.framecounter + 1

        if self.fields.framecounter >= self.framecount then
            self.fields.framecounter = 0
        end
    end
end

function animation:getquad()
    return love.graphics.newQuad(self.fields.framecounter * self.framewidth, 0, self.framewidth, self.frameheight, self.atlas:getDimensions())
end

return animation