tileset = {}
tileset.__index = tileset

function tileset:new(ta, td, w, h)
    local self = setmetatable({}, self)

    self.tileatlas = ta
    self.decorationatlas = td

    self.tilewidth = w
    self.tileheight = h

    return self
end

function tileset:getTile(t)
    return love.graphics.newQuad(tileset.tiles[t].x * self.tilewidth, tileset.tiles[t].y * self.tileheight, self.tileheight, self.tileheight, self.tileatlas:getDimensions())
end

function tileset:getDecoration(t)
    return love.graphics.newQuad(tileset.tiles[t].x * self.tilewidth, tileset.tiles[t].y * self.tileheight, self.tileheight, self.tileheight, self.decorationatlas:getDimensions())
end

function tileset.getIndex()

end

tileset.tiles = 
{
    { x = 0, y = 0 },
    { x = 1, y = 0 },
    { x = 2, y = 0 },
    { x = 0, y = 1 },
    { x = 1, y = 1 },
    { x = 2, y = 1 },
    { x = 0, y = 2 },
    { x = 1, y = 2 },
    { x = 2, y = 2 },

    { x = 3, y = 0 },
    { x = 4, y = 0 },
    { x = 3, y = 1 },
    { x = 4, y = 1 },

    { x = 3, y = 2 },
}

tileset.decorations = 
{
    { x = 0, y = 0 },
    { x = 1, y = 0 },
    { x = 0, y = 1 },
}

return tileset