local sprite = require("Sprites/sprite")

local functions = require("functions")

entity = {}
entity.__index = entity

function entity:new()
    local self = sprite.new(self)

    self.speed = 3
    self.tiles = {}

    self.cbools = 
    {
        touchingtop = false,
        touchingbottom = false,
        touchingleft = false,
        touchingright = false,
        collisionfound = false,
    }

    return self
end

function entity:update()
    self.cbools.collisionfound = false
    self.cbools.touchingup = false
    self.cbools.touchingdown = false
    self.cbools.touchingleft = false
    self.cbools.touchingright = false

    for k, v in pairs(self.tiles) do
        if functions.collision(self:rect(), v:rect()) then
            self.cbools.collisionfound = true

            self.tempvel = self.vel.y
            self.vel.y = 0

            if functions.collision(self:rect(), v:rect()) == false and self.tempvel > 0 then
                self.cbools.touchingtop = true

                self.vel.y = self.tempvel
                
                while functions.collision(self:rect(), v:rect()) do
                    self.vel.y = self.vel.y - 1
                end
            else
                self.vel.y = self.tempvel
            end

            self.tempvel = self.vel.y
            self.vel.y = 0

            if functions.collision(self:rect(), v:rect()) == false and self.tempvel < 0 then
                self.cbools.touchingtop = true

                self.vel.y = self.tempvel
                
                while functions.collision(self:rect(), v:rect()) do
                    self.vel.y = self.vel.y + 1
                end
            else
                self.vel.y = self.tempvel
            end

            self.tempvel = self.vel.x
            self.vel.x = 0

            if functions.collision(self:rect(), v:rect()) == false and self.tempvel > 0 then
                self.cbools.touchingleft = true

                self.vel.x = self.tempvel
                
                while functions.collision(self:rect(), v:rect()) do
                    self.vel.x = self.vel.x - 1
                end
            else
                self.vel.x = self.tempvel
            end

            self.tempvel = self.vel.x
            self.vel.x = 0

            if functions.collision(self:rect(), v:rect()) == false and self.tempvel < 0 then
                self.cbools.touchingright = true

                self.vel.x = self.tempvel
                
                while functions.collision(self:rect(), v:rect()) do
                    self.vel.x = self.vel.x + 1
                end
            else
                self.vel.x = self.tempvel
            end
        end
    end

    if self.cbools.touchingtop == false then
        
    end

    sprite.update(self)
end

function entity:draw()
    sprite.draw(self)

    --for k, v in pairs(self.tiles) do
    --    love.graphics.rectangle("fill", self:rect().x, self:rect().y, self:rect().width, self:rect().height)
    --    love.graphics.rectangle("fill", v:rect().x, v:rect().y, v:rect().width, v:rect().height)
    --end
end

return entity