local sprite = require("Sprites/sprite")
local entity = require("Sprites/Entities/entity")

local input = require("Models/Input")

local functions = require("functions")

player = {}
player.__index = player

function player:new()
    local self = entity.new(self)

    self.invToggled = false
    self.invTlgPressed = false

    return self
end

function player:update()
    if input.isDown(self.input.up) then
        self.vel.y = self.vel.y - self.speed
    end
    if input.isDown(self.input.down) then
        self.vel.y = self.vel.y + self.speed
    end
    
    if input.isDown(self.input.left) then
        self.vel.x = self.vel.x - self.speed

        self.hflip = true
    end
    if input.isDown(self.input.right) then
        self.vel.x = self.vel.x + self.speed

        self.hflip = false
    end

    if love.keyboard.isDown(self.input.inventory) and self.invTglPressed == false then
        self.invToggled = not self.invToggled
        self.invTglPressed = true
    end
    if not love.keyboard.isDown(self.input.inventory) then
        self.invTglPressed = false
    end

    entity.update(self)
end

function player:draw()
    entity.draw(self)

    if self.invToggled then
        self.inventory:draw()
    end

    --for k, v in pairs(self.tiles) do
    --    love.graphics.rectangle("fill", self:rect().x, self:rect().y, self:rect().width, self:rect().height)
    --    love.graphics.rectangle("fill", v:rect().x, v:rect().y, v:rect().width, v:rect().height)
    --end
end

return player