local sprite = require("Sprites/sprite")
local tileset = require("Models/tileset")

tile = {}
tile.__index = tile

function tile:new(t, x, y, s)
    local self = sprite.new(self)

    self.tileset = t

    self.x = x * self.tileset.tilewidth * statics.scale
    self.y = y * self.tileset.tileheight * statics.scale

    self.width = self.tileset.tilewidth
    self.height = self.tileset.tileheight

    self.shape = s

    self.quad = self.tileset:getTile(self.shape)

    return self
end

function tile:update(dt)

end

function tile:draw()
    love.graphics.draw(self.tileset.tileatlas, self.quad, self.x, self.y, 0, statics.scale, statics.scale)
end

return tile